// VRML Generator
// (c) Justin Couch
//
// From Chapter 13: Late Night VRML 2.0 and Java
//
// Static java class that contains the integer reference information
// that associates a VRML type with a name. Makes life easier for referencing
// and comparisons.

public final class VrmlTypes
{
	public static final int NumberOfTypes = 54;
	
	// Grouping Nodes
	public static final int Anchor = 0;
	public static final int BillBoard = 1;
	public static final int Collision = 2;
	public static final int Group = 3;
	public static final int Transform = 4;

	// Special Groups
	public static final int Inline = 5;
	public static final int LOD = 6;
	public static final int Switch = 7;

	// Common Nodes
	public static final int AudioClip = 8;
	public static final int DirectionalLight = 9;
	public static final int PointLight = 10;
	public static final int Script = 11;
	public static final int Shape = 12;
	public static final int Sound = 13;
	public static final int SpotLight = 14;
	public static final int WorldInfo = 15;

	// Sensors
	public static final int CylinderSensor = 16;
	public static final int PlaneSensor = 17;
	public static final int ProximitySensor = 18;
	public static final int SphereSensor = 19;
	public static final int TimeSensor = 20;
	public static final int TouchSensor = 21;
	public static final int VisibilitySensor = 22;

	// Geometry
	public static final int Box = 23;
	public static final int Cone = 24;
	public static final int Cylinder = 25;
	public static final int ElevationGrid = 26;
	public static final int Extrusion = 27;
	public static final int IndexedFaceSet = 28;
	public static final int IndexedLineSet = 29;
	public static final int PointSet = 30;
	public static final int Sphere = 31;
	public static final int Text = 32;

	// Geometric Properties
	public static final int Color = 33;
	public static final int Coordinate = 34;
	public static final int Normal = 35;
	public static final int TextureCoordinate = 36;

	// Appearance
	public static final int Appearance = 37;
	public static final int FontStyle = 38;
	public static final int ImageTexture = 39;
	public static final int Material = 40;
	public static final int MovieTexture = 41;
	public static final int PixelTexture = 42;
	public static final int TextureTransform = 43;

	// Interpolators
	public static final int ColorInterpolator = 44;
	public static final int CoordinateInterpolator = 45;
	public static final int NormalInterpolator = 46;
	public static final int OrientationInterpolator = 47;
	public static final int PositionInterpolator = 48;
	public static final int ScalarInterpolator = 49;

	// Bindable Nodes
	public static final int BackGround = 50;
	public static final int Fog = 51;
	public static final int NavigationInfo = 52;
	public static final int Viewpoint = 53;
}

// end of file VrmlTypes.java
